// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338
// ma_with_button.mq4
//+------------------------------------------------------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------------------------------------------------------+
// modified by banzai from Mario Jemic template 
// July 27th, 2020
// not for sale, rent, auction, nor lease
#property copyright "Alexander Elgin"
#property link      "alexmost113@mail.ru"
#property indicator_chart_window

#define PERIODS_NUMBER 5
#define INDICATOR_NAME "Fractal Support Resistance"
#define SUPPORT "Support"
#define RESISTANCE "Resistance"
#define BAR_TO_START_SCAN_FROM 2

extern string              note1                = "------------------------------";
extern color               H1Color              = clrGreen;
extern color               H4Color              = clrDodgerBlue;
extern color               D1Color              = clrDarkOrange;
extern color               W1Color              = clrRed;
extern color               MN1Color             = clrPurple;
extern string              note2                = "------------------------------";
extern ENUM_LINE_STYLE     H1LineStyle          = STYLE_DOT;
extern ENUM_LINE_STYLE     H4LineStyle          = STYLE_DOT;
extern ENUM_LINE_STYLE     D1LineStyle          = STYLE_SOLID;
extern ENUM_LINE_STYLE     W1LineStyle          = STYLE_SOLID;
extern ENUM_LINE_STYLE     MN1LineStyle         = STYLE_SOLID;
extern string              note3                = "------------------------------";
extern int                 H1LineWidth          = 1;
extern int                 H4LineWidth          = 1;
extern int                 D1LineWidth          = 1;
extern int                 W1LineWidth          = 1;
extern int                 MN1LineWidth         = 1;
extern string              note4                = "------------------------------";
extern bool               DisplayTextLabel      = true;
extern int                LabelFontSize         = 10;
extern string             LabelFont             = "Arial";
extern int                ShiftLabel            = 10;//Label Shift +move right -move left
/*
extern string             note5                 = "------------------------------";
extern string             Resistance3LabelFont     = "Arial";
extern int                Resistance3LabelFontSize = 8;
extern color              Resistance3Color      = clrLime;
extern color              Resistance3Label      = clrLime;
extern ENUM_LINE_STYLE    Resistance3Style      = STYLE_DASH;
extern int                Resistance3Width      = 1;
extern string             note6                 = "------------------------------";
extern string             Resistance2LabelFont     = "Arial";
extern int                Resistance2LabelFontSize = 8;
extern color              Resistance2Color      = clrGreen;
extern color              Resistance2Label      = clrGreen;
extern ENUM_LINE_STYLE    Resistance2Style      = STYLE_DASH;
extern int                Resistance2Width      = 1;
extern string             note7                 = "------------------------------";
extern string             Resistance1LabelFont     = "Arial";
extern int                Resistance1LabelFontSize = 8;
extern color              Resistance1Color      = clrDarkGreen;
extern color              Resistance1Label      = clrDarkGreen;
extern ENUM_LINE_STYLE    Resistance1Style      = STYLE_DASH;
extern int                Resistance1Width      = 1;
extern string             note8                 = "------------------------------";
extern string             PivotLabelFont           = "Arial Black";
extern int                PivotLabelFontSize       = 10;
extern color              PivotColor            = clrBlue;
extern color              PivotLabel            = clrBlue;
extern ENUM_LINE_STYLE    PivotStyle            = STYLE_SOLID;
extern int                PivotWidth            = 1;
extern string             note9                 = "------------------------------";
extern string             Support1LabelFont        = "Arial";
extern int                Support1LabelFontSize    = 8;
extern color              Support1Color         = clrMaroon;
extern color              Support1Label         = clrMaroon;
extern ENUM_LINE_STYLE    Support1Style         = STYLE_DASH;
extern int                Support1Width         = 1;
extern string             note10                 = "------------------------------";
extern string             Support2LabelFont        = "Arial";
extern int                Support2LabelFontSize    = 8;
extern color              Support2Color         = clrCrimson;
extern color              Support2Label         = clrCrimson;
extern ENUM_LINE_STYLE    Support2Style         = STYLE_DASH;
extern int                Support2Width         = 1;
extern string             note11                 = "------------------------------";
extern string             Support3LabelFont        = "Arial";
extern int                Support3LabelFontSize    = 8;
extern color              Support3Color         = clrRed;
extern color              Support3Label         = clrRed;
extern ENUM_LINE_STYLE    Support3Style         = STYLE_DASH;
extern int                Support3Width         = 1;
//+------------------------------------------------------------------------------------------------------------------+
*/
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "FSR";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             UniqueButtonID        = "FSR2020";
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
int timeframes[PERIODS_NUMBER] = {PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};

   int   styles[5];
   color colors[5];
   int   widths[5];

//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + UniqueButtonID;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
	string object_types[2] = {SUPPORT, RESISTANCE};
	
	for(int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++)
		for(int object_type_index = 0; object_type_index < ArraySize(object_types); object_type_index++)
		       {
			     ObjectDelete(getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			     ObjectDelete("banzai"+getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			    }
   colors[0] = H1Color;
   colors[1] = H4Color;
   colors[2] = D1Color;
   colors[3] = W1Color;
   colors[4] = MN1Color;
   
   styles[0] = H1LineStyle;
   styles[1] = H4LineStyle;
   styles[2] = D1LineStyle;
   styles[3] = W1LineStyle;
   styles[4] = MN1LineStyle;

   widths[0] = H1LineWidth;
   widths[1] = H4LineWidth;
   widths[2] = D1LineWidth;
   widths[3] = W1LineWidth;
   widths[4] = MN1LineWidth;   

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here
	string object_types[2] = {SUPPORT, RESISTANCE};
	for(int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++)
		for(int object_type_index = 0; object_type_index < ArraySize(object_types); object_type_index++)
		       {
			     ObjectDelete(getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			     ObjectDelete("banzai"+getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			    }
	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   //put start () here
	for(int timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++) {
		if(Period() <= timeframes[timeframe_index]) {
			drawResistance(getUpperFractalBar(timeframes[timeframe_index], BAR_TO_START_SCAN_FROM), timeframe_index);
			drawSupport(getLowerFractalBar(timeframes[timeframe_index], BAR_TO_START_SCAN_FROM), timeframe_index);
		}
	}
   
      if (show_data)
         {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
         }
      else
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
	    string object_types[2] = {SUPPORT, RESISTANCE};

	    for(timeframe_index = 0; timeframe_index < ArraySize(timeframes); timeframe_index++)
		    for(int object_type_index = 0; object_type_index < ArraySize(object_types); object_type_index++)
		       {
			     ObjectDelete(getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			     ObjectDelete("banzai"+getTrendLineName(object_types[object_type_index], timeframes[timeframe_index]));
			    }
      }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
void drawResistance(int bar_index, int timeframe_index) {
	if(bar_index > 0) drawTrendLine(getTrendLineName(RESISTANCE, timeframes[timeframe_index]), iHigh(Symbol(), timeframes[timeframe_index], bar_index), colors[timeframe_index], styles[timeframe_index], widths[timeframe_index]);
}
//+------------------------------------------------------------------+
int getUpperFractalBar(int timeframe, int starting_bar) {
	for(int bar = starting_bar; bar < Bars; bar++)
		if(isUpperFractal(timeframe, bar)) return(bar);
	return (-1);
}
//+------------------------------------------------------------------+
bool isUpperFractal(int timeframe, int bar) {
	for(int offset = -2; offset <= 2; offset++)
		if( (offset != 0) && (iHigh(Symbol(), timeframe, bar + offset) > iHigh(Symbol(), timeframe, bar)) ) return(false);
	return (true);
}
//+------------------------------------------------------------------+
int getLowerFractalBar(int timeframe, int starting_bar) {
	for(int bar = starting_bar; bar < Bars; bar++)
		if(isLowerFractal(timeframe, bar)) return(bar);
	return (-1);
}
//+------------------------------------------------------------------+
bool isLowerFractal(int timeframe, int bar) {
	for(int offset = -2; offset <= 2; offset++)
		if( (offset != 0) && (iLow(Symbol(), timeframe, bar + offset) < iLow(Symbol(), timeframe, bar)) ) return(false);
	return (true);
}
//+------------------------------------------------------------------+
void drawSupport(int bar_index, int timeframe_index) {
	if(bar_index > 0) drawTrendLine(getTrendLineName(SUPPORT, timeframes[timeframe_index]), iLow(Symbol(), timeframes[timeframe_index], bar_index), colors[timeframe_index], styles[timeframe_index], widths[timeframe_index]);
}
//+------------------------------------------------------------------+
void drawTrendLine(string object_name, double price, color line_color, int line_style, int line_width) {
	ObjectDelete(object_name);
	ObjectCreate(object_name, OBJ_HLINE, 0, Time[0], price, Time[Bars - 1], price);
	ObjectSet(object_name, OBJPROP_COLOR, line_color);
	ObjectSet(object_name, OBJPROP_STYLE, line_style);
	ObjectSet(object_name, OBJPROP_WIDTH, line_width);
   if (DisplayTextLabel)
      {
        ObjectDelete("banzai"+object_name);
        if (ObjectFind("banzai"+object_name)!=0)
           {
            ObjectCreate ("banzai"+object_name,OBJ_TEXT,0,Time[10]+Period()*60*ShiftLabel, price, Time[Bars - 1], price);
            ObjectSetText("banzai"+object_name,object_name,LabelFontSize,LabelFont,EMPTY);
            ObjectSet    ("banzai"+object_name,OBJPROP_COLOR,line_color);
           }
        else
            ObjectMove("banzai"+object_name,0,Time[10]+Period()*60*ShiftLabel, price);
      }
}
//+------------------------------------------------------------------+
string getTrendLineName(string object_type, int timeframe) {
	return(object_type + " " + getTimeframeName(timeframe));
}
//+------------------------------------------------------------------+
string getTimeframeName(int timeframe) {
	static int timeframe_periods[] = {PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};
	static string timeframe_names[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN1"};
	
	for(int i = 0; i < ArraySize(timeframe_periods); i++)
		if(timeframe == timeframe_periods[i]) return (timeframe_names[i]);

	return("Unknown");
}
//+------------------------------------------------------------------+
